package com.company.demo.view.order;

import com.company.demo.entity.Order;
import com.company.demo.entity.OrderItem;
import com.company.demo.view.main.MainView;
import com.vaadin.flow.component.AbstractField;
import com.vaadin.flow.router.Route;
import io.jmix.core.Metadata;
import io.jmix.flowui.component.checkbox.JmixCheckbox;
import io.jmix.flowui.component.grid.DataGrid;
import io.jmix.flowui.kit.action.ActionPerformedEvent;
import io.jmix.flowui.model.CollectionContainer;
import io.jmix.flowui.view.*;
import org.springframework.beans.factory.annotation.Autowired;

import java.time.LocalDate;
import java.util.ArrayList;

@Route(value = "orders/:id", layout = MainView.class)
@ViewController(id = "Order_.detail")
@ViewDescriptor(path = "order-detail-view.xml")
@EditedEntityContainer("orderDc")
public class OrderDetailView extends StandardDetailView<Order> {

    @Autowired
    Metadata metadata;

    @ViewComponent
    CollectionContainer<OrderItem> orderItemsDc;

    @Subscribe("readOnlyCheckbox")
    public void onReadOnlyCheckboxComponentValueChange(final AbstractField.ComponentValueChangeEvent<JmixCheckbox, Boolean> event) {
        this.setReadOnly(event.getValue());
    }

    @Subscribe("generateOrderItems")
    public void onGenerateOrderItems(final ActionPerformedEvent event) {
           OrderItem orderItem1 = metadata.create(OrderItem.class);
           orderItem1.setOrder(getEditedEntity());
           orderItem1.setName("Potatoes");
           orderItem1.setPrice(10);

           OrderItem orderItem2 = metadata.create(OrderItem.class);
           orderItem2.setOrder(getEditedEntity());
           orderItem2.setName("Tomatoes");
           orderItem2.setPrice(5);

           OrderItem orderItem3 = metadata.create(OrderItem.class);
           orderItem3.setOrder(getEditedEntity());
           orderItem3.setName("Coca-Cola");
           orderItem3.setPrice(50);

           if (getEditedEntity().getOrderitems() == null) {
               getEditedEntity().setOrderitems(new ArrayList<>());
           }
           getEditedEntity().getOrderitems().add(orderItem1);
           getEditedEntity().getOrderitems().add(orderItem2);
           getEditedEntity().getOrderitems().add(orderItem3);
    }

    @Subscribe("generateDate")
    public void onGenerateDate(final ActionPerformedEvent event) {
        getEditedEntity().setDate(LocalDate.now());
    }



    @Subscribe("refreshDataGrid")
    public void onRefreshDataGrid(final ActionPerformedEvent event) {
        orderItemsDc.setItems(getEditedEntity().getOrderitems());
    }
}